<?php

namespace Drupal\filtrosckeditor\Plugin\Filter;

use Drupal\filter\FilterProcessResult;
use Drupal\filter\Plugin\FilterBase;

use Drupal\Component\Utility\Html;  //agregamos este namespace

/**
 * @Filter(
 *   id = "filtrosckeditor",
 *   title = @Translation("Filtros customizados"),
 *   description = @Translation("Filtros customizados CKeditor y WYSIWYG"),
 *   type = Drupal\filter\Plugin\FilterInterface::TYPE_MARKUP_LANGUAGE,
 * )
 */
class filtrosckeditor extends FilterBase {
    //forma anterior.
    /*public function process($text, $langcode) {
        $replace = '<ul class="claseJhonatan"';
        $new_text = str_replace('<ul', $replace, $text);
       // return new FilterProcessResult($new_text);
        
       $result = new FilterProcessResult($new_text);
        $result->setAttachments(array(
          'library' => array('filtrosckeditor/libreriafiltrosckeditor'),
        ));
    
        return $result;
        
      }
      
      */
      
      
    public function process($text, $langcode) {
    // Creamos un documento DOM.
    $dom = Html::load($text);

    //Obtenemos todas las etiquetas UL, pero podemos obtener la que deseemos.
    $lists_query = '//ul'; 

    // Obtener los nodos DOM de la consulta XPath.
    $xpath = new \DOMXPath($dom);
    $nodes = $xpath->query($lists_query);
    
    // Si tenemos resultados.
    if ($nodes->length > 0) {
      //Iteramos sobre los elementos de la lista y agregar nuestra clase.
      foreach ($nodes as $node) {
        $classes = explode(' ', $node->getAttribute('class'));
        $classes[] = 'claseJhonatan';
        $node->setAttribute('class', join(' ', array_unique($classes)));
      }
    }
    
       $result = new FilterProcessResult(Html::serialize($dom));
        $result->setAttachments(array(
          'library' => array('filtrosckeditor/libreriafiltrosckeditor'),
        ));
    
        return $result;
    
    
    
  }  
      
      
      
      
      
      
      
      
      
      
      
      
      
      
}